use std::sync::Arc;

use vulkano::{image::view::ImageView, render_pass::{Framebuffer, FramebufferCreateInfo, RenderPass}};

pub fn make_framebuffer(render_pass: Arc<RenderPass>, attachments: Vec<Arc<ImageView>>) -> Result<Arc<Framebuffer>, vulkano::Validated<vulkano::VulkanError>> {
    let extent = attachments[0].image().extent();
    
    Framebuffer::new(render_pass.clone(), FramebufferCreateInfo {
        attachments,
        extent: [extent[0], extent[1]],
        layers: 1,
        ..Default::default()
    })
}
